// Generated by CoffeeScript 1.12.7
var extend = function(child, parent) { for (var key in parent) { if (hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  hasProp = {}.hasOwnProperty;

ez5.PdfCreator.Header = (function(superClass) {
  extend(Header, superClass);

  function Header() {
    return Header.__super__.constructor.apply(this, arguments);
  }

  Header.prototype.initOpts = function() {
    Header.__super__.initOpts.call(this);
    return this.addOpts({
      data: {
        check: "PlainObject",
        "default": {}
      }
    });
  };

  Header.prototype.readOpts = function() {
    var i, len, position, ref;
    Header.__super__.readOpts.call(this);
    this.__data = this._data;
    ref = ["left", "center", "right"];
    for (i = 0, len = ref.length; i < len; i++) {
      position = ref[i];
      if (this.__data[position]) {
        continue;
      }
      this.__data[position] = {};
    }
    return this;
  };

  Header.prototype.getData = function() {
    return this.__data;
  };

  Header.prototype.renderPdfContent = function(opts) {
    var _data, centerDiv, children, data, div, header, i, img, imgDiv, j, len, len1, node, object, position, ref, ref1, styleRight, text, textNodes, width;
    header = CUI.dom.div("pdf-node-" + (this.constructor.name.toLowerCase()));
    if (!opts.preview) {
      CUI.dom.setStyle(header, {
        "font-size": "8px",
        "padding-left": "0.28in",
        "padding-right": "0.28in",
        "width": "calc(100% - 0.56in)"
      });
    }
    data = this.getData();
    ref = ["left", "center", "right"];
    for (i = 0, len = ref.length; i < len; i++) {
      position = ref[i];
      div = CUI.dom.div();
      CUI.dom.append(header, div);
      CUI.dom.setStyle(div, {
        "display": "inline-block",
        "text-align": position,
        "min-height": opts.preview ? "12px" : "8px"
      });
      _data = data[position];
      if (_data.type === "logo") {
        if (!ez5.PdfCreator.logoImage) {
          continue;
        }
        CUI.dom.setStyle(div, {
          "min-height": 0
        });
        img = CUI.dom.element("img", {
          src: ez5.PdfCreator.logoImage
        });
        imgDiv = CUI.dom.div("pdf-node-header-image-" + position);
        CUI.dom.append(imgDiv, img);
        if (!opts.preview) {
          CUI.dom.setStyle(img, {
            "height": "0.3in"
          });
          CUI.dom.setStyle(imgDiv, {
            "position": "absolute",
            "margin-top": "-0.21in"
          });
          if (position === "right") {
            styleRight = opts.documentNode.isLandscape() ? 3.20 : 2.35;
            CUI.dom.setStyle(imgDiv, {
              "right": styleRight + "in"
            });
          }
        }
        CUI.dom.append(div, imgDiv);
      } else {
        text = ez5.loca.getBestFrontendValue(_data.text);
        if (!text) {
          continue;
        }
        CUI.dom.setStyle(div, {
          "white-space": "nowrap",
          "overflow": "hidden"
        });
        text = text.replace(/%pageNumber%/g, "<span class='pageNumber'>1</span>");
        text = text.replace(/%totalPages%/g, "<span class='totalPages'>" + (((ref1 = opts.objects) != null ? ref1.length : void 0) || 1) + "</span>");
        object = opts.objects[0];
        text = ez5.PdfCreatorUtils.replaceTextPlaceholders(text, object);
        textNodes = CUI.dom.htmlToNodes(text);
        CUI.dom.append(div, textNodes);
      }
    }
    centerDiv = header.children[1];
    if (!centerDiv.hasChildNodes()) {
      centerDiv.remove();
    }
    children = CUI.dom.children(header);
    width = 100 / children.length;
    for (j = 0, len1 = children.length; j < len1; j++) {
      node = children[j];
      CUI.dom.setStyle(node, {
        "width": width + "%"
      });
    }
    return header;
  };

  Header.prototype.getSettingsFields = function(opts) {
    var forms, getFields, i, len, position, ref;
    if (opts == null) {
      opts = {};
    }
    getFields = (function(_this) {
      return function(position) {
        var formFields, logoFieldDisabled, logoText, onDataChanged, textField, textHintButton;
        textHintButton = new CUI.Button({
          text: $$("pdf-creator.settings.node.header.text|hint"),
          appearance: "flat",
          onClick: function() {
            var pop;
            pop = new ez5.HintPopover({
              element: textHintButton,
              content: new CUI.Label({
                text: $$("pdf-creator.settings.node.header.text.popover"),
                markdown: true
              }),
              padded: true
            });
            return pop.show();
          }
        });
        textField = {
          type: CUI.MultiInput,
          form: {
            label: $$("pdf-creator.settings.node.header.text|label"),
            hint: textHintButton
          },
          control: ez5.loca.getLanguageControl(),
          name: "text"
        };
        if (position === "center" || !_this.__supportsLogo()) {
          return [textField];
        }
        onDataChanged = function(data, field) {
          var form;
          form = field.getForm();
          textField = form.getFieldsByName("text")[0];
          if (data.type === "logo") {
            textField.hide(true);
          } else {
            textField.show(true);
          }
        };
        logoFieldDisabled = !ez5.PdfCreator.logoImage;
        if (logoFieldDisabled) {
          logoText = $$("pdf-creator.settings.node.header.select.option-logo-disabled|label");
        } else {
          logoText = $$("pdf-creator.settings.node.header.select.option-logo|label");
        }
        formFields = [
          {
            type: CUI.Select,
            name: "type",
            form: {
              label: $$("pdf-creator.settings.node.header.select|label")
            },
            options: [
              {
                text: $$("pdf-creator.settings.node.header.select.option-text|label"),
                value: "text"
              }, {
                text: logoText,
                value: "logo",
                disabled: logoFieldDisabled
              }
            ],
            onDataInit: function(field, data) {
              return onDataChanged(data, field);
            },
            onDataChanged: onDataChanged
          }, textField
        ];
        return formFields;
      };
    })(this);
    forms = [];
    ref = ["left", "center", "right"];
    for (i = 0, len = ref.length; i < len; i++) {
      position = ref[i];
      forms.push({
        type: CUI.Form,
        form: {
          label: $$("pdf-creator.settings.node.header.title." + position + "|label")
        },
        render_as_block: true,
        name: position,
        fields: getFields(position),
        data: this.getData()
      });
    }
    return forms;
  };

  Header.prototype.__supportsLogo = function() {
    return true;
  };

  Header.prototype.getSaveData = function() {
    return CUI.util.copyObject(this.getData(), true);
  };

  return Header;

})(CUI.Element);
